    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------
    028     * CompositeTitle.java
    029     * -------------------
    030     * (C) Copyright 2005, by David Gilbert and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: CompositeTitle.java,v 1.14.2.1 2005/10/25 20:58:34 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 19-Nov-2004 : Version 1 (DG);
    040     * 11-Jan-2005 : Removed deprecated code in preparation for 1.0.0 release (DG);
    041     * 04-Feb-2005 : Implemented MAXIMUM_WIDTH in calculateSize (DG);
    042     * 20-Apr-2005 : Added new draw() method (DG);
    043     * 03-May-2005 : Implemented equals() method (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.title;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Rectangle2D;
    051    import java.io.Serializable;
    052
    053    import org.jfree.chart.block.BlockContainer;
    054    import org.jfree.chart.block.BorderArrangement;
    055    import org.jfree.chart.block.RectangleConstraint;
    056    import org.jfree.ui.Size2D;
    057
    058    /**
    059     * A title that contains multiple titles within a {@link BlockContainer}.
    060     */
    061    public class CompositeTitle extends Title implements Cloneable, Serializable {
    062
    063        /** For serialization. */
    064        private static final long serialVersionUID = -6770854036232562290L;
    065
    066        /** A container for the individual titles. */
    067        private BlockContainer container;
    068
    069        /**
    070         * Creates a new composite title with a default border arrangement.
    071         */
    072        public CompositeTitle() {
    073            this(new BlockContainer(new BorderArrangement()));
    074        }
    075
    076        /**
    077         * Creates a new title using the specified container.
    078         *
    079         * @param container  the container (<code>null</code> not permitted).
    080         */
    081        public CompositeTitle(BlockContainer container) {
    082            if (container == null) {
    083                throw new IllegalArgumentException("Null 'container' argument.");
    084            }
    085            this.container = container;
    086        }
    087
    088        /**
    089         * Returns the container holding the titles.
    090         *
    091         * @return The title container (never <code>null</code>).
    092         */
    093        public BlockContainer getContainer() {
    094            return this.container;
    095        }
    096
    097        /**
    098         * Sets the title container.
    099         *
    100         * @param container  the container (<code>null</code> not permitted).
    101         */
    102        public void setTitleContainer(BlockContainer container) {
    103            if (container == null) {
    104                throw new IllegalArgumentException("Null 'container' argument.");
    105            }
    106            this.container = container;
    107        }
    108
    109        /**
    110         * Arranges the contents of the block, within the given constraints, and
    111         * returns the block size.
    112         *
    113         * @param g2  the graphics device.
    114         * @param constraint  the constraint (<code>null</code> not permitted).
    115         *
    116         * @return The block size (in Java2D units, never <code>null</code>).
    117         */
    118        public Size2D arrange(Graphics2D g2, RectangleConstraint constraint) {
    119            RectangleConstraint contentConstraint = toContentConstraint(constraint);
    120            Size2D contentSize = this.container.arrange(g2, contentConstraint);
    121            return new Size2D(
    122                calculateTotalWidth(contentSize.getWidth()),
    123                calculateTotalHeight(contentSize.getHeight())
    124            );
    125        }
    126
    127        /**
    128         * Draws the title on a Java 2D graphics device (such as the screen or a
    129         * printer).
    130         *
    131         * @param g2  the graphics device.
    132         * @param area  the area allocated for the title.
    133         */
    134        public void draw(Graphics2D g2, Rectangle2D area) {
    135            area = trimMargin(area);
    136            drawBorder(g2, area);
    137            area = trimBorder(area);
    138            area = trimPadding(area);
    139            this.container.draw(g2, area);
    140        }
    141
    142        /**
    143         * Draws the block within the specified area.
    144         *
    145         * @param g2  the graphics device.
    146         * @param area  the area.
    147         * @param params  ignored (<code>null</code> permitted).
    148         *
    149         * @return Always <code>null</code>.
    150         */
    151        public Object draw(Graphics2D g2, Rectangle2D area, Object params) {
    152            draw(g2, area);
    153            return null;
    154        }
    155
    156        /**
    157         * Tests this title for equality with an arbitrary object.
    158         *
    159         * @param obj  the object (<code>null</code> permitted).
    160         *
    161         * @return A boolean.
    162         */
    163        public boolean equals(Object obj) {
    164            if (obj == this) {
    165                return true;
    166            }
    167            if (!(obj instanceof CompositeTitle)) {
    168                return false;
    169            }
    170            if (!super.equals(obj)) {
    171                return false;
    172            }
    173            CompositeTitle that = (CompositeTitle) obj;
    174            if (!this.container.equals(that.container)) {
    175                return false;
    176            }
    177            return true;
    178        }
    179
    180    }